<template>
  <b-navbar class="mt-header" :mobile-burger="false" shadow>
    <template #brand>
      <b-navbar-item tag="nuxt-link" :to="{ name: 'index' }">
        <img
          src="/logo-ministere-des-armees.png"
          srcset="/logo-ministere-des-armees.png 172w"
          sizes="(max-width: 320px) 52px,
            (max-width: 480px) 62px,
            84px"
          alt="Logo du ministère des armées"
        />
        <img
          src="/metiis-logotype-bleu.png"
          srcset="/metiis-logotype-bleu.png 570w"
          sizes="(max-width: 320px) 56px,
            (max-width: 480px) 68px,
            89px"
          alt="Logo Metiis"
        />
      </b-navbar-item>
      <div v-if="utilisateur" class="columns is-vcentered is-mobile">
        <b-navbar-item class="right is-hidden-mobile" tag="div">
          <div class="is-size-7 has-text-right">
            <nuxt-link :to="{ name: 'infos-persos' }"><mt-utilisateur :utilisateur="utilisateur"/></nuxt-link>
          </div>
          <div>
            <b-field>
              <b-select size="is-small" :value="profil" placeholder="Choisir un profil" expanded @input="setProfil">
                <option
                  v-for="userProfil in utilisateur.userProfils"
                  :key="userProfil.profil.id"
                  :value="userProfil.profil.code"
                >
                  {{ userProfil.profil.description }}
                </option>
              </b-select>
            </b-field>
          </div>
          <div>
            <b-field v-if="isAdminLocal">
              <b-select
                size="is-small"
                :value="organisme"
                placeholder="Choisir un organisme"
                expanded
                @input="setOrganisme"
              >
                <optgroup v-for="list in getListeOrganisme()" :key="list[0]" :label="list[0]">
                  <option v-for="userOrganisme in list[1]" :key="userOrganisme.id" :value="userOrganisme">
                    {{ userOrganisme.code }}
                  </option>
                </optgroup>
              </b-select>
            </b-field>
          </div>
        </b-navbar-item>
        <b-navbar-item class="right is-hidden-mobile is-size-7" tag="div">
          <nuxt-link :to="{ name: 'infos-persos' }">
            <mt-pastille cursor="pointer">{{ utilisateur.initial }}</mt-pastille></nuxt-link
          >
        </b-navbar-item>
        <b-navbar-item tag="div">
          <mt-bell />
        </b-navbar-item>
        <b-navbar-item>
          <nuxt-link :to="{ name: 'aide' }"><b-icon icon="help-circle"></b-icon></nuxt-link>
        </b-navbar-item>
        <b-navbar-item class="cursor-as-pointer" tag="div">
          <mt-menu />
        </b-navbar-item>
      </div>
    </template>
  </b-navbar>
</template>

<script>
import MtMenu from '~/components/base/basic-layout/menu/index';
import MtBell from '~/components/alerte/bell';
import userMixin from '~/components/mixins/userMixin';
import MtPastille from '~/components/base/pastille/index';
import MtUtilisateur from '~/components/pax/mt-utilisateur';

export default {
  name: 'MtHeader',
  components: {
    MtUtilisateur,
    MtPastille,
    MtMenu,
    MtBell,
  },
  mixins: [userMixin],
  methods: {
    async setProfil(profil) {
      this.getListeOrganisme();
      this.$store.dispatch('context/setProfil', profil);
      const monOrganisme = this.$store.state.auth.user.affectation.organisme;
      if (this.$store.getters['context/isAdminLocal']) {
        const organismes = await this.$api.organismes.affectableAllowed();
        await this.$store.dispatch('context/setOrganismes', organismes);
        let index = 0;
        for (let i = 0; i < organismes.length; i += 1) {
          if (organismes[i].id === monOrganisme.id) {
            index = i;
            break;
          }
        }
        await this.$store.dispatch('context/setOrganisme', organismes[index]);
      } else {
        await this.$store.dispatch('context/setOrganisme', monOrganisme);
      }
      this.redirect();
    },
    setOrganisme(organisme) {
      this.$store.dispatch('context/setOrganisme', organisme);
      this.redirect();
    },
    getListeOrganisme() {
      const organismes = new Map();
      this.listeOrganismes.forEach(function setOrganismes(organisme) {
        let tabOrg = organismes.get(organisme.codeParent);
        if (!tabOrg) {
          tabOrg = [];
        }
        tabOrg.push(organisme);
        organismes.set(organisme.codeParent, tabOrg);
      });
      return Array.from(organismes);
    },
    redirect() {
      const namesRoutes = [
        'profil',
        'profil-activites-id',
        'profil-annuelle',
        'profil-activites',
        'profil-pax',
        'infos-persos',
        'alertes',
      ];
      const profil = this.$store.getters['context/profil'];
      if (namesRoutes.includes(this.$nuxt.$route.name)) {
        const maRoute = {
          name: this.$nuxt.$route.name,
          params: this.$nuxt.$route.params,
          query: this.$nuxt.$route.query,
        };
        maRoute.params.profil = profil;
        this.$router.push(maRoute);
      } else {
        this.$router.push({
          name: 'profil',
          params: { profil },
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-header {
  padding: 0 1.95vw;
}
.menu-list {
  margin-bottom: 10px;
}
.has-shadow {
  box-shadow: 0 2px 2px -1px rgba(164, 164, 164, 0.28);
}
.right {
  margin-right: -0.75rem;
  flex-direction: column;
  align-items: stretch;
  cursor: default;
  color: red;
  /deep/ {
    .control {
      line-height: 1em;
    }
    .select {
      height: 1rem;
      display: flex;
      align-items: center;
      &::after,
      &:hover::after {
        border-color: white;
        border-top-color: $grey;
        border-style: solid;
        height: 0;
        width: 0;
        border-width: 5px;
        border-radius: 0;
        transform: unset;
        top: auto;
        border-bottom-width: 0;
        margin: 0;
        right: 0;
        transition: border-top-color 0.3s;
      }
      &:hover::after {
        border-top-color: $brown-grey;
      }
      select {
        color: $brown-grey;
        height: 1rem;
        margin: 0;
        border: none;
        padding: 0 1em 0 0;
        text-align: right;
        border-radius: 0;
      }
    }
  }
}
/deep/ {
  .navbar-brand {
    width: 100%;
    justify-content: space-between;
    margin-left: 0 !important;
  }
  .navbar-menu {
    display: none;
  }
  .navbar-item img {
    max-height: unset;
    margin: 15px 30px 15px 0;
  }
  .select {
    z-index: 0;
  }
  @media (max-width: 440px) {
    .navbar-item img {
      max-height: unset;
      margin: 15px 10px 15px 0;
    }
  }
}
</style>
